<template>
	<div id="body">
			
		<div class="container bg-light">
			<div class="row">
				<div class="col-md-4">
					<div>
						<h2 class="pull-left" v-if="state === 1"><span class="label label-default">1</span></h2>
						<h2 class="pull-left" v-if="state > 1"><span class="label label-danger">1</span></h2>
					</div>
					<h4 class="pull-left topbar">Select a date</h4>	
					<p class="pull-left topbar2">Choose the length of your stay.</p>					
				</div>
				<div class="col-md-4">
					<div>
						<h2 class="pull-left" v-if="state < 2"><span class="label label-default white">2</span></h2>
						<h2 class="pull-left" v-if="state === 2"><span class="label label-default">2</span></h2>
						<h2 class="pull-left" v-if="state > 2"><span class="label label-danger">2</span></h2>
					</div>
					<h4 class="pull-left topbar">Pick a Room</h4>	
					<p class="pull-left topbar2">Choose the room which fits your needs.</p>
				</div>
				<div class="col-md-4">
					<div>
						<h2 class="pull-left" v-if="state < 3"><span class="label label-default white">3</span></h2>
						<h2 class="pull-left" v-if="state === 3"><span class="label label-default">3</span></h2>
					</div>
					<h4 class="pull-left topbar">Finish Reservation</h4>	
					<p class="pull-left topbar2">Check and confirm your reservation.</p>
				</div>
				<div class="col-md-12">
					<h3>{{hotel.name}}</h3>
				</div>
				<div class="col-md-12"><br></div>
			</div>
		</div>

			<div id="componentContainer">
				<InformationComponent v-if="state === 1" :formdata="formdata" @step:next="next()"></InformationComponent>
				<RoomComponent v-if="state === 2 " :rooms="hotel.rooms" :formdata="formdata" @step:refresh="refresh()" @step:next="next()"></RoomComponent>
				<OverviewComponent v-if="state === 3" :formdata="formdata" :name="hotel.name"></OverviewComponent>
			</div>	

			 
	        <div class="col-md-12"><br></div>  		
		</div>
</template>

<script>

	import InformationComponent from "@/components/Booking/InformationComponent.vue";
	import RoomComponent from "@/components/Booking/RoomComponent.vue";
	import OverviewComponent from "@/components/Booking/OverviewComponent";

	import HotelComponent from "@/components/hotelcomponent.vue";
	import Hotel from "@/models/Hotel.js";
	import axios from "axios";

	export default{
		name: 'booking1',
		components: {
			HotelComponent,
			InformationComponent,
			RoomComponent, 
			OverviewComponent,
		},
		props: {
		},
		data(){
			return{
				formdata: {
					gender: {
						value: '',
						err: '',
					},
					firstName: {
						value: '',
						err: '',
					},
					lastName: {
						value: '',
						err: '',
					},
					departureDate: {
						value: '',
						err: '',
					},
					returnDate: {
						value: '',
						err: '',
					}, 
					rooms: {
						value: 1, 
						err: '', 
					},
					roomList: [],

				},
				hotel:{},
				hotelId: 0,
				state: 1, 
				data: {

				},

			}
		},
		mounted(){

			this.hotelId =this.$route.params.hotelId;
		axios.get('data/data.json').then((response) => {
			var hotels = response.data.map(Hotel.fromJson);
			this.hotel = hotels[hotels.findIndex(this.findHotel)];
			console.log(this.hotel);
			}
			).catch((err) =>{
				console.log(err);
			})			
		},
		methods: {
			findHotel(hotel){
				return hotel.id == this.hotelId;
			},
			next(){
				this.state++;
			},
			prev(){
				this.state--;
			},
			refresh(){
				console.log("refresh");
				this.next();
				this.prev();
			}
		}
	}

</script>

<style> 

	.form-group{
		padding-top: 10px;
	}
	.topbar{
		margin: 10px;
		margin-top: 30px;
		margin-bottom: 0px;
	}
	.topbar2{
		margin: 10px;
		margin-top: 0;
	}
	.white{
		background-color: white;
		color: black;
	}

</style>